"use strict";
var DeviceLogProvider = (function () {
    function DeviceLogProvider($logFilter, $logger) {
        this.$logFilter = $logFilter;
        this.$logger = $logger;
    }
    DeviceLogProvider.prototype.logData = function (lineText, platform, deviceIdentifier) {
        var data = this.$logFilter.filterData(platform, lineText);
        if (data) {
            this.$logger.out(data);
        }
    };
    DeviceLogProvider.prototype.setLogLevel = function (logLevel, deviceIdentifier) {
        this.$logFilter.loggingLevel = logLevel.toUpperCase();
    };
    return DeviceLogProvider;
}());
exports.DeviceLogProvider = DeviceLogProvider;
$injector.register("deviceLogProvider", DeviceLogProvider);
