"use strict";
var PlatformLiveSyncServiceBase = (function () {
    function PlatformLiveSyncServiceBase(_device, $liveSyncProvider) {
        this._device = _device;
        this.$liveSyncProvider = $liveSyncProvider;
    }
    Object.defineProperty(PlatformLiveSyncServiceBase.prototype, "device", {
        get: function () {
            return (this._device);
        },
        enumerable: true,
        configurable: true
    });
    PlatformLiveSyncServiceBase.prototype.refreshApplication = function (deviceAppData, localToDevicePaths, forceExecuteFullSync) {
        var canExecuteFastSync = !forceExecuteFullSync && localToDevicePaths !== undefined;
        for (var _i = 0, localToDevicePaths_1 = localToDevicePaths; _i < localToDevicePaths_1.length; _i++) {
            var localToDevicePath = localToDevicePaths_1[_i];
            if (!this.$liveSyncProvider.canExecuteFastSync(localToDevicePath.getLocalPath(), deviceAppData.platform)) {
                canExecuteFastSync = false;
                break;
            }
        }
        if (canExecuteFastSync) {
            return this.reloadPage(deviceAppData);
        }
        return this.restartApplication(deviceAppData);
    };
    return PlatformLiveSyncServiceBase;
}());
exports.PlatformLiveSyncServiceBase = PlatformLiveSyncServiceBase;
